#pragma once

#include "NControl.h"
#include "ScriptletContainerFactory.h"
#include "Binding.h"

class ItemPanel;
class CListBox;
class NPCOMMONUI_API Item
{
public:
	Item(void)
	{
		m_ItemPanel = NULL;
		m_bSelected = FALSE;
	}
	virtual ~Item() {}

	virtual CString ToString();
	
	void SetItemPanel(ItemPanel* panel)
	{
		m_ItemPanel = panel;
	}
	ItemPanel* GetItemPanel() { return m_ItemPanel; }
	BOOL Select(BOOL bSelect);
	BOOL IsSelected();

private:
	ItemPanel*	m_ItemPanel;
	BOOL m_bSelected;
};

class NPCOMMONUI_API ItemPanel : public CNControl
{
public:
	DECLARE_COMPONENT_CREATOR(ItemPanel)
	ItemPanel(void);
	virtual ~ItemPanel(void);

	//override
	void OnHideNotify();

	//operation
	void SetItem(Item* pItem);
	Item* GetItem() { return m_Item; }
	void Select();
	void Unselect();

	virtual void OnSetItem(Item* pItem) {}

protected:
	virtual void OnSelected() {}
	virtual void OnUnselected() {}

private:
	Item* m_Item;
};
